/*************** Practica 04. Especificacion clase ColaClientes **************
 *
 *  Nombre de Fichero: ColaClientes.h
 *
 *  Proposito: Declaracion de la interfaz de la clase cola de clientes
 *
 *****************************************************************************/
#include "ColaE.h"

const double LLEGADA = 50;   // tiempo medio de llegada de clientes

class ColaClientes
{
   public:
      //Constructor
      ColaClientes::ColaClientes(void);
      //Indica si la cola est vacia
      bool ColaVacia(void);
      //Entra un nuevo cliente y se coloca en la cola
      void Entrar(Cola::Valor);
      //Sale cliente de la cola
      void Salir(Cola::Valor);
      //Guarda cuando llegar el siguiente cliente
      void Siguiente(Cola::Valor);
      //Comprueba si ha llegado un cliente
      bool LlegaCliente(Cola::Valor);
      //Muestra las estadsticas de la cola de clientes
      void Estadisticas(Cola::Valor);
   private:
      Cola::Cola cola; //Objeto tipo cola
      // Variables para el clculo de las estadsticas de la cola de clientes
      int longitud,  // n de clientes que hacen cola en un momento dado
      tam_max_cola,  // longitud mxima que ha alcanzado la cola
      total_clientes, //n total de clientes que se han acercado al establecimiento
      clientes_perdidos; //n de clientes que han rehusado hacer cola
      Cola::Valor llega_en,  //cuando llegar el prximo cliente
      tiempo_ult_suceso, //momento en el que se realiz una entrada o una salida
      tiempo_total_espera, //tiempo total que han esperado los clientes
      tiempo_max_espera,  //tiempo mximo que ha esperado un cliente
      tam_total_cola; //Sirve para calcular el tamao medio de cola. Es la suma
       //acumulada de los productos de los tamaos de la cola por la cantidad de
       //tiempo que la cola tuvo ese tamao

      //Devuelve true si el cliente rehusa ponerse a la cola
      bool Rehusa();
      //Simula la hora de llegada del siguiente cliente
      Cola::Valor LlegadaSiguiente(Cola::Valor );
};
