/*************** Practica 04. Implementacion clase Cola ***********************
 *
 *  Nombre de Fichero: ColaE.cpp
 *
 *  Proposito: En este archivo se implementan los diferentes metodos de la
 *             clase cola
 *
 *****************************************************************************/
#include "ColaE.h"
#include <stdlib.h>
#include <iostream.h>
using namespace std;

/********************************************************/
/*Constructor de la la clase Cola                       */
/********************************************************/
Cola::Cola(void)
{
   ini = 0;
   fin = 0;     //posicion inicio y fin de cola
}

/********************************************************/
/*Poner un elemento en la Cola. Si Cola esta llena      */
/*devuelve true                                         */
/********************************************************/
bool Cola::Encolar(Cola::Valor x)
{
   bool error;
   
   if (Siguiente(fin) == ini)
      error = true;
   else
   {
      error = false;
      info[fin] = x;
      fin = Siguiente(fin);
   }
   
   return error;
}

/********************************************************/
/*Sacar un elemento en la Cola. Si Cola esta vacia      */
/*devuelve true                                         */
/********************************************************/
bool Cola::Desencolar(Cola::Valor & x)
{
   bool error;
   
   if (ColaVacia())
      error = true;
   else
   {
      error = false;
      x = info[ini];
      ini = Siguiente(ini);
   }
   
   return error;
}

/********************************************************/
/*Comprueba si la cola esta vacia y devuelve true       */
/********************************************************/
bool Cola::ColaVacia(void)
{
   bool error;
   
   if (ini == fin)
      error = true;
   else
      error = false;
      
   return error;
}

/********************************************************/
/*Informa del primer elemento de la Cola. Si Cola esta  */
/*vacia devuelve true                                   */
/********************************************************/
bool Cola::PrimeroCola(Cola::Valor & x)
{
   bool error;
   
   if (ColaVacia())
      error = true;
   else
   {
      error = false;
      x = info[ini];
   }
   
   return error;
}

/********************************************************/
/*Indica el siguiente elemento de la cola               */
/********************************************************/
int Cola::Siguiente(int x)
{
   return (x+1)%MAX;
}

