/*************** Practica 04. Implementacion clase Servidor *******************
 *
 *  Nombre de Fichero: Servidor.cpp
 *
 *  Proposito: En este archivo se implementan los diferentes metodos de la
 *             clase servidor
 *
 *****************************************************************************/
#include <stdlib.h>
#include <math.h>
#include <iostream.h>
#include <time.h>
#include "Servidor.h"

using namespace std;

/********************************************************/
/*Constructor de la la clase Servidor                   */
/********************************************************/
Servidor::Servidor(void)
{
 srand(time(NULL));
 clientes_atendidos = 0;
 ocupado_hasta = 0;
 tiempo_total_atencion = 0;
}
/*************** DisponibleEn *******************************************
 *
 *  Prototipo: Servidor::Valor Servidor::DisponibleEn(Servidor::Valor tiempo_actual)
 *
 *  Descripcion:  Simula cuanto tardar el servidor en atender al cliente
 *
 *  Parametros:
 *  Nombre          Tipo        E/S  Descripcion
 *  ------          ----------  ---  ------------
 *  tiempo_actual   Servidor::Valor  E   hora actual
 *
 *  Valor devuelto:
 *  Servidor::Valor  hora en la que quedar libre el servidor
 *
 ************************************************************************/
Servidor::Valor Servidor::DisponibleEn(Servidor::Valor tiempo_actual)
{
   Servidor::Valor x, r;

   r = rand();
   x = -log(1 - (r/Servidor::Valor(RAND_MAX)))/ ATENCION;
   return tiempo_actual + (ATENCION * exp(-ATENCION * x));
}
/*************** AtenderCliente *******************************************
 *
 *  Prototipo: void Servidor::AtenderCliente(Servidor::Valor tiempo_actual)
 *
 *  Descripcion:  El servidor atiende al cliente
 *
 *  Parametros:
 *  Nombre          Tipo        E/S  Descripcion
 *  ------          ----------  ---  ------------
 *  tiempo_actual   Servidor::Valor  E   hora actual
 *
 *  Valor devuelto:
 *  void
 *
 ************************************************************************/
void Servidor::AtenderCliente(Servidor::Valor tiempo_actual)
{
 ocupado_hasta = DisponibleEn(tiempo_actual);
 tiempo_total_atencion += ocupado_hasta - tiempo_actual;
 clientes_atendidos++;
}
/*************** Ocupado ************************************************
 *
 *  Prototipo:    bool Servidor::Ocupado(Servidor::Valor tiempo_actual)
 *
 *  Descripcion:  Indica si el servidor est libre u ocupado
 *
 *  Parametros:
 *  Nombre          Tipo        E/S  Descripcion
 *  ------          ----------  ---  ------------
 *  tiempo_actual   Cola::Valor  E   hora actual
 *
 *  Valor devuelto:
 *  bool
 *          true  -> El servidor est oucpado
 *          false -> El servidor no est oucpado
 *
 ************************************************************************/
bool Servidor::Ocupado(Servidor::Valor tiempo_actual)
{
 bool res = true;

 if (tiempo_actual > ocupado_hasta)
     res = false;
 return res;
}
/*************** Estadsticas *******************************************
 *
 *  Prototipo:    void Servidor::Estadisticas(Servidor::Valor tiempo_actual)
 *
 *  Descripcion:  Muestra las estadsticas del servidor
 *
 *  Parametros:
 *  Nombre          Tipo        E/S  Descripcion
 *  ------          ----------  ---  ------------
 *  tiempo_actual   Cola::Valor  E   hora actual
 *
 *  Valor devuelto:
 *  void
 *
 ************************************************************************/
void Servidor::Estadisticas(Servidor::Valor tiempo_actual, Servidor::Valor tfin)
{
 cout << endl << "ESTADSTICAS DEL SERVIDOR" << endl;
 cout << "\tClientes atendidos: " << clientes_atendidos << endl;
 cout << "\tTiempo medio de atencin(seg): " << tiempo_total_atencion / clientes_atendidos << endl;
 cout << "\tOcupacin servidor: " << (tiempo_total_atencion / tfin)*100 << endl;
}

