/********************************************/
/* Simulacin de colas                      */
/*                                          */
/* AUTOR: Torres Martnez, Emiliano         */
/* FECHA: 29 de marzo de 2004               */
/*                                          */
/* PROPOSITO: Simulacin de un sistema con  */
/* un servidor y una cola                   */
/*                                          */
/********************************************/
#include <iostream.h>
#include <stdlib.h>
#include "ColaClientes.h"
#include "Servidor.h"

/********************************************/
/*                                          */
/*                  MAIN()                  */
/*                                          */
/********************************************/

int main()
{
   Cola::Valor tfin=28800; // 8 horas de jornada son 28800 segundos
   Cola::Valor t=0;       // hora actual del reloj en segundos
   ColaClientes colaclientes;
   Servidor servidor;

   //Calcula la llegada del primer cliente
   colaclientes.Siguiente(t);
   //Simula un reloj digital con incremento de un segundo
   for (t=1;t<tfin;t++)
   {
     if (colaclientes.LlegaCliente(t))
     {
      cout<<"Entra: "<<t<<endl;
      colaclientes.Entrar(t);
      //Calcula la llegada del siguiente cliente
      colaclientes.Siguiente(t);
     }
     if (!servidor.Ocupado(t) && !colaclientes.ColaVacia())
     {
       cout<<"Sale: "<<t<<endl;
       colaclientes.Salir(t);
      //Calcula cuando pasa a estar libre el servidor
       servidor.AtenderCliente(t);
      }
   }
   colaclientes.Estadisticas(t);
   servidor.Estadisticas(t, tfin);

   system("pause");
   return 0;
}

